#pragma once
#include <QWidget>
#include <QTableView>
#include <QStandardItemModel>
#include <QStyledItemDelegate>
#include <QItemDelegate>

/// <summary>
/// 
/// </summary>
class IntDelegate : public QStyledItemDelegate {
	Q_OBJECT
private:
	int _min_value, _max_value;

signals:
	void valueChanged(const QModelIndex &idx) const;

public:
	IntDelegate(int min, int max);

	virtual QWidget* createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index) const override;
	virtual void setEditorData(QWidget* editor, const QModelIndex& index) const override;
	virtual void setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const override;
	virtual void updateEditorGeometry(QWidget* editor, const QStyleOptionViewItem& option, const QModelIndex& index) const override;
};

#include <QHash>
#include <memory>
class ExtractUnit;
class TranslateBasic {
private:
	QHash<QString, std::shared_ptr<ExtractUnit>> _extractor_types;
	std::shared_ptr<ExtractUnit> _default_translate_rule;

public:
	TranslateBasic();

	std::shared_ptr<ExtractUnit> defaultRule() const;
	QHash<QString, std::shared_ptr<ExtractUnit>> extactors() const;

};

class RuleSelectDelegate : public QStyledItemDelegate {
	Q_OBJECT
private:
	std::shared_ptr<TranslateBasic> _kernel;

signals:
	void dataChanged(const QModelIndex &idx) const;

public:
	RuleSelectDelegate(std::shared_ptr<TranslateBasic> ins);

	virtual QWidget* createEditor(QWidget* parent, const QStyleOptionViewItem& option, const QModelIndex& index) const override;
	virtual void setEditorData(QWidget* editor, const QModelIndex& index) const override;
	virtual void setModelData(QWidget* editor, QAbstractItemModel* model, const QModelIndex& index) const override;
	virtual void updateEditorGeometry(QWidget* editor, const QStyleOptionViewItem& option, const QModelIndex& index) const override;
};

class SequenceView : public QTableView {
private:
	QStandardItemModel* const _seqs_model;
	std::shared_ptr<TranslateBasic> base = nullptr;
	QList<std::shared_ptr<ExtractUnit>> _rule_list;

public:
	void tidyRuleAt(const QModelIndex& idx_rule);

public:
	SequenceView(QWidget* p = nullptr);

	void customTranslateRuleEdit(const QPoint& pos);
	void addTranslateUnit();
	void removeTranslateUnit();
};

